#line 1 "E:/Elettronica/Circuiti/Filtro chiamate anonime/Progetto/MikroC/Filtro.c"
#line 77 "E:/Elettronica/Circuiti/Filtro chiamate anonime/Progetto/MikroC/Filtro.c"
unsigned int TimeOutTime = 600;
#line 104 "E:/Elettronica/Circuiti/Filtro chiamate anonime/Progetto/MikroC/Filtro.c"
enum STS {
 STS_STBY=0,
 STS_MTYP,
 STS_MLEN,
 STS_DATA,
 STS_NUMB,
 STS_FTYP,
 STS_FLEN,
 STS_FCHR,
 STS_CKSM,
 STS_FINE
};


unsigned short CurBit;
unsigned short CurByte;
unsigned short Idx;
unsigned short MLen;
unsigned short MTyp;
unsigned short FLen;
unsigned short FTyp;
unsigned short Stato;
unsigned short DataSum;
char *CurField;
char DateTime[8];
char Nome[30];
char Number[20];
unsigned short ChkSum;
unsigned int CntTimer;
char *CurString;
unsigned int StringLen;
unsigned int StringIdx;
unsigned short Cur_GPIO;
unsigned short Prev_GPIO;





unsigned short EndData() {



unsigned char ret;

 if (Idx >= MLen) ret =  1 ;
 else ret =  0 ;
 return ret;
}

unsigned short GetCurByte() {




unsigned short b;

 b = CurByte;
 CurByte = 0;
 Idx++;
 DataSum += b;
 return b;
}

void InitString(char *s, int Len) {




 CurString = s;
 CurString[0] = 0;
 StringIdx = 0;
 StringLen = Len;
}

void CollectString() {



unsigned short c;

 c=GetCurByte();
 strncat(CurString,&c,1);
 StringIdx++;
}

unsigned short EndString() {



unsigned short ret;

 if (StringIdx<StringLen) ret =  0 ;
 else ret =  1 ;
 return ret;
}

void RifiutaChiamata() {



 GPIO. F0 =1;
 Delay_ms( 2000 );
 GPIO. F0 =0;
}

void ProcessByte() {




 switch (Stato) {
 case STS_MTYP :
 MTyp = GetCurByte();
 if ((MTyp==0x80)||(MTyp==0x04)) {
 DataSum = MTyp;
 Idx = 1;
 Stato = STS_MLEN;
 }
 break;
 case STS_MLEN :
 MLen = GetCurByte();
 MLen++;
 switch (MTyp) {
 case 0x04:
 InitString(DateTime,8);
 Stato = STS_DATA;
 break;
 case 0x80:
 Stato = STS_FTYP;
 break;
 default:
 GPIO. F4  = 1;
 Stato = STS_FINE;
 break;
 }
 break;
 case STS_DATA :
 CollectString();
 if (EndString()== 1 ) {
 InitString(Number,MLen-8);
 Stato = STS_NUMB;
 }
 break;
 case STS_NUMB :
 CollectString();
 if (EndString()== 1 ) {
 Stato = STS_CKSM;
 }
 break;
 case STS_FTYP :
 FTyp = GetCurByte();
 Stato = STS_FLEN;
 break;
 case STS_FLEN :
 FLen = GetCurByte();
 switch (FTyp) {
 case 0x01: InitString(DateTime,FLen); break;
 case 0x02: InitString(Number,FLen); break;
 case 0x04: InitString(Number,FLen); break;
 case 0x07: InitString(Nome,FLen); break;
 case 0x08: InitString(Nome,FLen); break;
 }
 Stato = STS_FCHR;
 break;
 case STS_FCHR :
 CollectString();
 if (EndString()== 1 )
 if (EndData()== 1 ) Stato = STS_CKSM;
 else Stato = STS_FTYP;
 break;
 case STS_CKSM :
 ChkSum = GetCurByte();
 GPIO. F4  = 1;
 Stato = STS_FINE;
 if (DataSum==0) {
 if ((Number[0]==0x50)||(Number[0]==0x4F)) {
 RifiutaChiamata();
 }
 }
 break;
 }
 CurByte=0;
}





void StartTimer() {




 INTCON.T0IE = 1;
 INTCON.T0IF = 0;
 TMR0 = 100;
}

void ResetTimer() {



 INTCON.T0IE = 0;
 CntTimer = 0;
 INTCON.T0IE = 1;
}

void StopTimer() {



 INTCON.T0IE = 0;
 INTCON.T0IF = 0;
}

void interrupt() {






 if ((INTCON.GPIF==1) && (INTCON.GPIE==1)) {

 Prev_GPIO = Cur_GPIO;
 Cur_GPIO = GPIO;


 if ((Prev_GPIO. F5 ==0) && (Cur_GPIO. F5 ==1)) {
 StartTimer();
 ResetTimer();
 if (Stato==STS_STBY) {
 GPIO. F4  = 0;
 Stato = STS_MTYP;
 CurByte = 0;
 }
 }



 if ((Prev_GPIO. F1 ==0) && (Cur_GPIO. F1 ==1)) {
 CurByte >>= 1;
 CurByte.F7 = Cur_GPIO. F2 ;
 }


 if ((Prev_GPIO. F3 ==1) && (Cur_GPIO. F3 ==0)) {
 ProcessByte();
 }

 INTCON.GPIF = 0;
 }


 if ((INTCON.T0IF==1) && (INTCON.T0IE==1)) {
 CntTimer++;
 if (CntTimer>TimeOutTime) {
 Stato = STS_STBY;
 GPIO. F4  = 1;
 StopTimer();
 }
 else
 StartTimer();
 }
}

void main() {







 ANSEL = 0;
 CMCON0 = 0x07;
 OPTION_REG = 0x85;


 TRISIO. F2  = 1;
 TRISIO. F3  = 1;
 TRISIO. F1  = 1;
 TRISIO. F5  = 1;
 TRISIO. F0  = 0;
 TRISIO. F4  = 0;


 IOC. F2  = 0;
 IOC. F3  = 1;
 IOC. F1  = 1;
 IOC. F5  = 1;


 GPIO. F4  = 1;
 GPIO. F0  = 0;


 Delay_ms(4000);


 INTCON.GIE = 1;
 INTCON.GPIE = 1;
 INTCON.INTE = 0;
 INTCON.INTF = 0;


 Cur_GPIO = 0;
 Prev_GPIO = 0;


 Stato = STS_STBY;





 while ( 1 ) {
 if (Stato==STS_STBY) {asm{sleep};}
 else Delay_us(1);
 }
}
